#include "TextAnalyse.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

TextAnalyse::TextAnalyse()
{
	enable  = false;
	mem     = false;
	buffer  = 0;
	pos     = 0;
	last    = 0;
	strsize = 0;
}

TextAnalyse::~TextAnalyse()
{
	release();
}

//eLXgt@C̓ǂݍ
bool TextAnalyse::load( const char *path )
{
	FILE *fp;

	if( enable ) release();

	fp = fopen( path, "rb" );
	if( fp == 0 ) return false;

	fseek( fp, 0L, SEEK_END );
	strsize = ftell( fp );
	fseek( fp, 0L, SEEK_SET );

	buffer = new char[strsize + 1];
	fread( buffer, strsize, 1, fp );
	fclose( fp );
	buffer[strsize] = '\0';

	enable = true;
	mem    = false;
	pos    = buffer;
	last   = buffer + strsize;

	return true;
}

//̃eLXg̉͂ݒ
bool TextAnalyse::setmem( const char *string, int size )
{
	if( size < 0 ) size = strlen( string );
	if( enable ) release();

	buffer  = (char *)string;
	strsize = size;
	enable  = true;
	mem     = true;
	pos     = buffer;
	last    = buffer + strsize;

	return true;
}

//ǂݍ񂾃eLXgt@CJ
bool TextAnalyse::release( void )
{
	if( enable == false ) return true;

	if( mem == false ) delete []buffer;
	buffer = 0;
	pos    = 0;
	last   = 0;
	enable = false;
	mem    = false;

	return true;
}

//͈ʒu擪ɖ߂
void TextAnalyse::reset( void )
{
	pos = buffer;
}

//w̍WɈړ
bool TextAnalyse::move( const char *pos )
{
	if( pos < buffer || pos >= last ) return false;
	this->pos = (char *)pos;
	return true;
}

//݂̍W擾
char *TextAnalyse::getpos( void )
{
	return pos;
}

//w̕񂪂ʒûPoCg܂ňړ(ꍇ͈ړȂ)
bool TextAnalyse::search( const char *str )
{
	char *p;
	char buffer[1024];

	p = pos;

	for(;;)
	{
		if( getstr( buffer ) == false ) break;
		if( strcmp( buffer, str ) == 0 ) break;
	}

	if( pos >= last )
	{
		pos = p;
		return false;
	}

	return true;
}

//̕擾
bool TextAnalyse::getstr( char *buf, bool nomove )
{
	int i, j;
	char *temp;

	next();
	temp = pos;
	if( pos >= last ) return false;

	//ŏ̕ " ǂŏ𕪊
	if( pos[0] == '\"' )
	{
		// " Ƃ܂ŃRs[
		pos++;
		for( j = 0, i = 0; pos + i < last && pos[i] != '\"'; )
		{
			if( checksize( pos + i ) == 2 )
			{
				buf[j  ] = pos[i  ];
				buf[j+1] = pos[i+1];
				i += 2;
				j += 2;
			}
			else
			{
				//̌Ɂhꍇ́h𕶎̈ꕔƂĂ݂Ȃ
				if( pos + i + 1 < last && pos[i] == '\\' && pos[i+1] == '\"' )
				{
					buf[j] = '\"';
					j++;
					i += 2;
				}
				else
				//sA^u͖
				if( pos[i] != '\r' && pos[i] != '\n' && pos[i] != '\t' )
				{
					buf[j] = pos[i];
					j++;
					i++;
				}
				else
				{
					i++;
				}
			}
		}
		buf[j] = '\0';
		pos += i;
		if( *pos == '\"' ) pos++;
	}
	else
	{
		//ӖƂ܂ŃRs[
		for( i = 0; pos + i < last && checkC( pos[i] ) == true; )
		{
			if( checksize( pos + i ) == 2 )
			{
				buf[i  ] = pos[i  ];
				buf[i+1] = pos[i+1];
				i += 2;
			}
			else
			{
				buf[i] = pos[i];
				i ++;
			}
		}
		buf[i] = '\0';
		pos += i;
	}

	if( nomove ) pos = temp;

	return true;
}

//̃oCg𓾂
int TextAnalyse::checksize( const char *str )
{
	return ( (unsigned char)*str >= 0x81 && (unsigned char)*str <= 0x9F ) || ( (unsigned char)*str >= 0xE0 && (unsigned char)*str <= 0xFC ) ? 2 : 1 ;
}

//Ӗ̂P܂Ŕ
bool TextAnalyse::next( void )
{
	for(;;)
	{
		if( pos >= last ) return false;

		//Rg΂
		if( pos[0] == '/' && pos[1] == '/' )
		{
			pos += 2;
			for(; pos < last && pos[0] != '\n'; pos += checksize( pos ) ){}
			if( pos >= last ) return false;
			pos ++;
		}
		else
		if( pos[0] == '/' && pos[1] == '*' )
		{
			pos += 2;
			for(; pos < last && ( pos[0] != '*' || pos[1] != '/' ) ; pos += checksize( pos ) ){}
			if( pos >= last ) return false;
			pos += 2;
		}
		else
		//󔒂΂
		if( checkC( *pos ) == false )
		{
			for(; pos < last && checkC( *pos ) == false; pos ++ ){}
			if( pos >= last ) return false;
		}
		else break ;
	}

	return true;
}

//O[vXLbv
bool TextAnalyse::skipgroup( const char *groupPre, const char *groupPost )
{
	char str[256];
	int count;

	if( search( groupPre ) == false ) return false;

	count = 1;
	for(;;)
	{
		if( getstr( str ) == false ) return false;

		if( strcmp( groupPre, str ) == 0 )
		{
			count ++ ;
		}
		else
		if( strcmp( groupPost, str ) == 0 )
		{
			count -- ;
			if( count == 0 ) return true;
		}
	}
}

//Ӗ̂镶ׂ
bool TextAnalyse::checkC( char str )
{
	return str != '\0' && str != ' ' && str != '\t' && str != '\n' && str != '\r';
}

//ɈӖ̂P̍ŏ̕擾( -1:t@C̏I[ )
char TextAnalyse::nextchar( void )
{
	if( next() == false ) return -1;
	return *pos;
}




